
/*
 *	emul06.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1984 by Robert Krten, all rights reserved.
 *
 *	This module contains the emulation for instructions 0 through 6
 *	inclusive.  It is a concatenation of previously separate files
 *
 *	1984 12 23	R. Krten		created
 *	1992 07 04	R. Krten		compounded
*/

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

#include "pdp8i.h"

void
exec_and (op)
int		op;
{
	pdp8.ac &= fetch (ea (op)) | 010000;	/* byte | LINK */
	pdp8.pc++;
}

void
exec_dca (op)
int		op;
{
	store (ea (op), pdp8.ac);
	pdp8.ac &= 010000L;
	pdp8.pc++;
}

void
exec_iot (op)
int		op;
{
	/* unimplemented */
	op = op;
	pdp8.pc++;
}

void
exec_isz (op)
int		op;
{
	store (ea (op), fetch (ea (op)) + 1);
	if (fetch (ea (op)) == 0) {
		pdp8.pc++;		/* skip if zero */
	}
	pdp8.pc++;	/* next instruction */
}

void
exec_jmp (op)
int		op;
{
	pdp8.pc = ea (op);	/* get address */
}

void
exec_jms (op)
int		op;
{
	store (ea (op), pdp8.pc + 1);
	pdp8.pc = ea (op);
}

void
exec_tad (op)
int		op;
{
	pdp8.ac += fetch (ea (op));
	pdp8.pc++;
}

