
/*
 *	exec.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1985 by Robert Krten, all rights reserved.
 *
 *	This module contains the main execution logic.
 *
 *	1985 07 20	R. Krten		created
*/

#include "pdp8i.h"

void	exec_and ();
void	exec_tad ();
void	exec_isz ();
void	exec_dca ();
void	exec_jms ();
void	exec_jmp ();
void	exec_iot ();
void	exec_opr ();

int	(*jt_exec [8]) () =
{
	exec_and,	exec_tad,	exec_isz,	exec_dca,
	exec_jms,	exec_jmp,	exec_iot,	exec_opr
};

int oldclass = 8;		/* fake, will regen */

void
run ()
{
	int escflag;

#ifdef HIF
	locate (8, 78);
	pcvwca (0xdb, COLOR_STATUS);
	escflag = 0;
	while (!escflag) {
		if (char_waiting ()) {
			switch (tolower (getchar ())) {
			case 'f':
				optf = 1 - optf;
				break;
			case 'e':
				escflag = 1;
				break;
			case 's':
				exec ();
				display ();
				while (tolower (getchar ()) == 's') {
					exec ();
					display ();
				}
				break;
			}
		} else {
			exec ();
			display ();
		}
	}
	locate (8, 78);
	pcvwca (' ', COLOR_STATUS);
#else /* HIF */
	for (;; exec ());
#endif /* HIF */
}

/* execute the instruction at memory location pdp8.pc */

void
exec ()
{
	int op;
	int class;

	if (!optf) {
		locate (6, 71);
		pcvwca (0xdb, COLOR_STATUS);
	}
	op = fetch (pdp8.pc);					/* fetch the addressed op */
	class = (op & 07000) >> 9;				/* get operand class */
	showclas (class);						/* show it about */
	(*jt_exec [class]) (op);				/* jump table */
#ifdef HIF
	if (!optf) {
		locate (6, 71);
		pcvwca (' ', COLOR_STATUS);
	}
#endif /* HIF */
}

void
showclas (c)
int c;
{
#ifdef HIF
	if (optf) return;
	if (oldclass != c) {
		locate (2 * oldclass + 4, 64);
		pcvwca (' ', COLOR_OPCLASS);
		locate (2 * c + 4, 64);
		pcvwca (0xdb, COLOR_OPCLASS);
		oldclass = c;
	}
#endif /* HIF */
}

