
/*
 *	hif.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1985 by Robert Krten, all rights reserved.
 *
 *	This module contains the human interface logic.
 *
 *	1985 07 20	R. Krten		created
*/

#include "pdp8i.h"

#ifdef HIF
static struct pdp8tag oldpdp8;
#endif /* HIF */

void
display ()
{
#ifdef HIF
	/* compares the states of oldpdp8 and pdp8 */

	if (pdp8.ac != oldpdp8.ac) reg (RAC);
	if (pdp8.pc != oldpdp8.pc) reg (RPC);
	if (pdp8.mb != oldpdp8.mb) reg (RMB);
	if (pdp8.ma != oldpdp8.ma) reg (RMA);
	if (pdp8.mq != oldpdp8.mq) reg (RMQ);
	copystat (&oldpdp8, &pdp8);		/* update */
	term_flush ();
#endif /* HIF */
}

void
copystat (t, s)
struct	pdp8tag	*t;		/* target */
struct	pdp8tag	*s;		/* source */
{
#ifdef HIF
	memcpy (t, s, sizeof (struct pdp8tag));
#endif /* HIF */
}

void
reg (r)
int r;
{
#ifdef HIF
	long	val;		/* value of that register */
	long	oldval;		/* old value of that register */
	long 	mask;
	int		maskpos;
	int		i;

	if (optf && (r != RAC)) {
		return;
	}

	switch (r) {
	case RAC:
		val = pdp8.ac;
		oldval = oldpdp8.ac;
		break;
	case RPC:
		val = pdp8.pc;
		oldval = oldpdp8.pc;
		break;
	case RMB:
		val = pdp8.mb;
		oldval = oldpdp8.mb;
		break;
	case RMA:
		val = pdp8.ma;
		oldval = oldpdp8.ma;
		break;
	case RMQ:
		val = pdp8.mq;
		oldval = oldpdp8.mq;
		break;
	}
	mask = 1L;								/* bit zero */
	maskpos = 0;							/* start at bit zero */
	for (i = 0; i < reglen [r]; i++) {
		if ((val & mask) != (oldval & mask)) {	/* we must change */
			locate (regline [r], regloc [maskpos]);
			pcvwca ((val & mask) == 0 ? ' ':0xdb, COLOR_BIT);
		}
		mask <<= 1;
		maskpos++;
	}
#endif /* HIF */
}

void
initp8 ()
{
	pdp8.ac = 000000L;
	pdp8.pc = 00000;
	pdp8.mb = 00000;
	pdp8.ma = 00000;
	pdp8.mq = 0000000L;

#ifdef HIF
	oldpdp8.ac = 017777L;
	oldpdp8.pc = 07777;
	oldpdp8.mb = 07777;
	oldpdp8.ma = 07777;
	oldpdp8.mq = 0377777L;
#endif /* HIF */

	memset (memory, 0, 8192 * sizeof (int));
}

void
title ()
{
#ifdef HIF
	int x;
	int y;

	cls ();
	for (y = 0; y < 5; y++) {				/* do registers */
		for (x = 0; x < reglen [y]; x++) {
			box (regloc [x], regline [y]);	/* give box */
		}
	}

	locate (regline [0] - 2, regloc [8] - 6);
	xprint ("P r o g r a m   C o u n t e r");
	locate (regline [1] - 2, regloc [8] - 5);
	xprint ("M e m o r y   A d d r e s s");
	locate (regline [2] - 2, regloc [8] - 3);
	xprint ("M e m o r y   B u f f e r");
	locate (regline [3] - 2, regloc [8] - 1);
	xprint ("A c c u m u l a t o r");
	locate (regline [3] - 2, regloc [ILINK] - 2);
	xprint ("Link");
	locate (regline [4] - 2, regloc [ISC4] + 1);
	xprint ("Step Counter");
	locate (regline [4] - 2, regloc [8] - 9);
	xprint ("M u l t i p l i e r   Q u o t i e n t");
	locate ( 4, 60);	xprint ("AND");
	locate ( 6, 60);	xprint ("TAD");
	locate ( 8, 60);	xprint ("ISZ");
	locate (10, 60);	xprint ("DCA");
	locate (12, 60);	xprint ("JMS");
	locate (14, 60);	xprint ("JMP");
	locate (16, 60);	xprint ("IOT");
	locate (18, 60);	xprint ("OPR");

	locate ( 4, 67);	xprint ("FET");
	locate ( 6, 67);	xprint ("EXE");
	locate ( 8, 67);	xprint ("DEF");
	locate (10, 67);	xprint ("WCT");
	locate (12, 67);	xprint ("CAD");
	locate (14, 67);	xprint ("BRK");

	locate ( 4, 74);	xprint ("ION");
	locate ( 6, 74);	xprint ("PAU");
	locate ( 8, 74);	xprint ("RUN");
#endif /* HIF */
}

static char remap [3][3] =
{
	{ 218, 179, 192 },
	{ 196,  32, 196 },
	{ 191, 179, 217 }
};

void
box (px, py)
int px;
int py;
{
#ifdef HIF
	int x;
	int y;

	for (x = px - 1; x < px + 2; x++) {
		for (y = py - 1; y < py + 2; y++) {
			if (x != px || y != py) {
				locate (y, x);	/* get there */
				pcvwca (remap [x - px + 1][y - py + 1], COLOR_BOX);
			}
		}
	}
#endif /* HIF */
}

