
/*
 *	main.c
 *
 *	QNX 4, main.c shell version 0.004
 *
 *	(C) Copyright 1984 by Robert Krten, all rights reserved.
 *
 *	This module represents the main module for the PDP-8 emulator
 *
 *	This program will simulate a PDP-8/I processor.
 *
 *	This program accepts a command line consisting of the following
 *	options:
 *
 *		[+verbose]
 *
 *	1984 12 23	R. Krten		created
 *	1992 07 04	R. Krten		ported to QNX 4
*/

#include "pdp8i.h"

static	void	usage (int);
static	void	optproc (int, char **);

char	*progname = "pdp8";
char	*blankname= "    ";
extern	char *version;					/* version.c */

int		optv;

void
usage (n)
int		n;
{
	printf ("usage:  %s programfilename\n", progname);
	if (n) {
		exit (n);
	}
}

static char buf [512];

void
main (argc, argv)
int		argc;
char	**argv;
{
	FILE	*fp;
	int		data;
	int		addr;

	if (argc != 2) {
		usage (1);
	}

#ifdef HIF
	OSInitDisplay ();
	title ();						/* show some titles */
	display ();						/* show it */
#endif /* HIF */

	initp8 ();						/* initialize the machine state */

	if ((fp = fopen (argv [1], "r")) != NULL) {
		while (!feof (fp) && fgets (buf, 512, fp) != NULL) {
			buf [strlen (buf) - 1] = 0;
			if (sscanf (buf, "%o %o", &addr, &data) != 2) {
				fprintf (stderr, "%s:  invalid octal address or data encountered \"%s\"\n", progname, buf);
				exit (1);
			}
			store (addr, data);
		}
		fclose (fp);
	} else {
		fprintf (stderr, "%s:  can't open %s for read\n", progname, argv [1]);
		exit (1);
	}

	run ();

#ifdef	HIF
	OSStopDisplay ();
#endif	/* HIF */
}

