
/*
 *	opr.c
 *
 *	QNX	4
 *
 *	(C)	Copyright 1984 by Robert Krten,	all	rights reserved.
 *
 *	This module	contains the Operate Micro-instructions	logic.
 *
 *	1984 12	30	R. Krten		created
*/

#include "pdp8i.h"

#define	cla()		lac (0);
#define	cll()		ll (0);

void
exec_opr (op)
int	op;
{
	if (op & BIT8) {
		if (op & BIT11) {
			exec_eae (op);
		} else {
			if (op & BIT3) {
				exec_g2b (op);
			} else {
				exec_g2a (op);
			}
		}
	} else {
		exec_g1 (op);
	}
}

void
exec_eae (op)
int	op;
{
	op = op;
	pdp8.pc++;	/* ignore */
}

void
exec_g1	(op)
int	op;
{
	int	ac;
	int	count;
	int	l;
	int	i;

	if (op & BIT7) {
		cla	();
	}

	if (op & BIT6) {
		cll	();
	}

	if (op & BIT5) {
		ac = (~pdp8.ac)	& 07777;
		cla	();
		lac	(ac);
	}

	if (op & BIT4) {
		l =	(pdp8.ac & 010000) >> 9;
		l =	(1 - l)	& 01;	/* complement */
		ll (l);
	}

	count =	(op	& 00002) >>	1;
	for	(i = 0;	i <= count;	i++) {
		if (op & BIT3) {
			if (pdp8.ac	& 01) {
				pdp8.ac	>>=	1;
				ll (1);
			} else {
				pdp8.ac	>>=	1;
				ll (0);
			}
		}

		if (op & BIT4) {
			pdp8.ac	<<=	1;
			if (pdp8.ac	& 020000) {
				pdp8.ac	&= 017777;
				pdp8.ac	|= 1;
			} else {
				pdp8.ac	&= 017776;
			}
		}
	}

	if (op & BIT0) {
		pdp8.ac++;
	}

	pdp8.pc++;
}

void
lac	(n)
int	n;
{
	int	l;

	l =	(pdp8.ac & 010000L)	>> 12;			/* link	*/
	pdp8.ac	= n;							/* load	it */
	ll (l);									/* save	link */
}

void
ll (n)
{
	if (n &	01) {
		pdp8.ac	|= 010000L;
	} else {
		pdp8.ac	&= 07777L;
	}
}

void
exec_g2a (op)
int	op;
{
	int	skip;

	skip = 0;		/* do not skip,	unless > 0 */

	if (op & BIT6) {
		if (pdp8.ac	& 004000L) {
			skip++;
		}
	}

	if (op & BIT5)	{
		if ((pdp8.ac & 007777L)	== 0) {
			skip++;
		}
	}

	if (op & BIT4)	{
		if (pdp8.ac	& 010000L) {
			skip++;
		}
	}

	if (op & BIT7) {
		cla	();
	}

	if (op & BIT2) {
		/* osr not supported */
	}

	if (op & BIT1) {
		pdp8.pc--;
	}

	if (skip) {
		pdp8.pc++;
	}
	pdp8.pc++;	/* normal increment	*/
}

void
exec_g2b (op)
int	op;
{
	int	skip;

	skip = 0;		/* no skip unless >	0 */

	if (op & BIT6) {
		if ((pdp8.ac & 04000L) == 0) {
			skip++;
		}
	}

	if (op & BIT5) {
		if (pdp8.ac	& 03777) {
			skip++;
		}
	}

	if (op & BIT4) {
		if ((pdp8.ac & 010000L)	== 0) {
			skip++;
		}
	}

	if (op & BIT7) {
		cla	();
	}

	if (op & BIT2) {
		/* osr not supported */
	}

	if (op & BIT1) {
		pdp8.pc--;	/* predecrement	*/
	}

	if (skip) {
		pdp8.pc++;
	}

	pdp8.pc++;	/* normal increment	*/
}

